#include <stdio.h>
#include "matrix.h"

MATRIX *convolution( MATRIX *img, MATRIX *win, int kw )
{
	MATRIX *OUT;
	int i, j, k, l, s;
	int sum, val;
	byte *ptrin, *ptrout;
	int *ptrw;

	OUT = matrix_allocate( img->rows, img->cols, sizeof(byte) );
	if ( OUT==NULL ) {
		fprintf( stderr, "ERROR allocating memory for output image\n" );
		return NULL;
	}
	for ( i=0; i < img->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i];
		for ( j=0; j < img->cols; j++ ) 
			*ptrout++ = 0;
	}

	/** Suponemos que la ventana es cuadrada y de taqmao impar **/
	k = win -> rows / 2;

	for ( i=0; i <= img->rows - win->rows; i++ ) {
		ptrout = (byte *) OUT->ptr[i + k] + k;

		for ( j=0; j <= img->cols - win->cols; j++ ) {
			sum = 0;
			for ( l=0; l < win->rows; l++ ) {
				ptrin = (byte *)img->ptr[ i + l ] + j;
				ptrw = (int *)win->ptr[ l ];
				for ( s=0; s < win->cols; s++ ) 
					sum += *ptrin++ * *ptrw++;
			}
			val = (int)( (1.0/kw)*sum + 0.5 );
			*ptrout++ = (val<0) ? 0 : (val>255) ? 255 : (byte)val;
		}
	}

	return OUT;	
}
